# CostaPy
# Copyright (C) 2022 Dita Aji Pratama
#
# This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
# You should have received a copy of the GNU General Public License along with this program. If not, see https://www.gnu.org/licenses/.

from    bottle                  import Bottle, route, request, response
from    config                  import directory

import  json

import  templates.plain.main	as template_public
import  modules.public.home     as public_home

app = Bottle()

@app.route('/')
def index():
    params = {
        "mako":{
            "website" : template_public.main(directory.page["public"], "home")
        }
    }
    return public_home.main().html(params)

@app.route('/api/<crud>', method=['OPTIONS', 'GET', 'POST', 'PUT', 'DELETE'])
def list(crud):
    # Untuk menentukan tipe konten pada respon, yaitu: JSON
    response.content_type = 'application/json'
    # Mengambil request pada body, yaitu berformat JSON
    params = request.json
    # Keluaran default
    keluaran = {
        "status":"Gagal",
        "message":"Anda tidak ada otoritas untuk menggunakan endpoint ini",
        "endpoint":f"/api/{crud}",
        "data":[]
    }
    
    if crud == "create":
        keluaran["status"] = "Berhasil"
        keluaran["message"] = "Dummy: Selamat data anda telah ditambah"
        keluaran["data"] = {
            "food":params["food"]
        }
    
    elif crud == "read":
        keluaran["status"] = "Berhasil"
        keluaran["message"] = "Dummy: Data collected"
        keluaran["data"] = [
            "Banana",
            "Apple",
            "Marshmallow"
        ]
    
    elif crud == "update":
        keluaran["status"] = "Berhasil"
        keluaran["message"] = "Dummy: Belum dibikin"
        keluaran["data"] = {
            "old":params["key"],
            "new":params["change"]
        }
    
    elif crud == "delete":
        keluaran["status"] = "Berhasil"
        keluaran["message"] = "Dummy: Belum dibikin"
    
    else:
        pass

    return json.dumps(keluaran, indent = 2).encode()
